$.data(document.body, "screenData", {
  elements: {
    main: "#maincontent",
  },
});

function customTemplateScript(screenData) {
  initOpenClose();
  initAccordion();
  initMobileNav();
  initLayout();
  initEvents();
  initErrorReporting();
  initBehavior();
  setupState(screenData.Items[0]);
}

function setupState(item) {
  var progressBarColor;
  removeStateClasses();

  if (item.Type == "Free" || item.Type == "FreeAllDay") {
    $("body").addClass("green");
    progressBarColor = "#70c664";
  } else if (item.Type == "Future" || item.Type == "Unavailable") {
    if (item.MinutesToStart <= 15) {
      $("body").addClass("yellow");
      progressBarColor = "#da812b";
    } else {
      $("body").addClass("green");
      progressBarColor = "#70c664";
    }
  } else {
    $("body").addClass("red");
    progressBarColor = "#d2123b";
  }
  renderProgressbar(item, progressBarColor);
}

function renderProgressbar(item, color) {
  $("#circle").circleProgress({
    value: calculateCircleValue(item),
    size: 350,
    startAngle: -Math.PI / 2,
    animation: false,
    reverse: true,
    thickness: 37,
    fill: { color: color },
    lineCap: "round",
  });
}

function calculateCircleValue(item) {
  if (item.Type === "Future" || item.Type == "Unavailable") {
    if (item.MinutesToStart <= 15) {
      return item.MinutesToStart / 60;
    }
  } else if (item.Type == "UnavailableNow") {
    return 1;
  } else if (
    item.HoursLeft != null &&
    item.HoursLeft < 1 &&
    item.MinutesLeft != null &&
    item.MinutesLeft <= 57
  ) {
    return item.MinutesLeft / 60;
  }
  return 1;
}

function removeStateClasses() {
  $("body").removeClass("red");
  $("body").removeClass("green");
  $("body").removeClass("yellow");
}
