﻿function GetDateFor(elemId) {
    var value = new Date($('#' + elemId + 'year').val(), $('#' + elemId + 'month').val() - 1, $('#' + elemId + 'day').val());
    if (isNaN(value)) {
        return null;
    }
    return value;
}

function DatePicker(name, minTime, maxTime, endPickerName, openToLeft, dateOrder, currentDate, inline, autoUpdate) {
    if (dateOrder === null) {
        dateOrder[0] = 0;
        dateOrder[1] = 1;
        dateOrder[2] = 2;
    }

    $(function () {
        var elementId = name + (inline ? '' : 'date-pick-button');
        var $datePicker = $('#' + elementId)
		    .datePicker(
			{
			    createButton: false,
			    startDate: minTime,
			    endDate: maxTime,
			    inline: inline,
			    showYearNavigation: false,
			    verticalOffset: (inline ? 10 : 0),
			    horizontalOffset: (inline ? 10 : 0),
			    horizontalPosition: openToLeft ? $.dpConst.POS_RIGHT : $.dpConst.POS_LEFT
			})
			.bind(
        // when the link is clicked display the date picker
			    'click',
			    function () {
			        if (!inline) {
			            if (elementId.indexOf("Rdate") > -1) {//TODO fix these reschedule datepicker, should not use id detection
			                $(this).dpSetPosition($.dpConst.POS_BOTTOM, $.dpConst.POS_LEFT);
			            }
			            $(this).dpDisplay();
			        }
			        return false;
			    })
			.bind(
        // when a date is selected update the SELECTs
			    'dateSelected',
			    function (e, selectedDate, $td, state) {
			        selectedDate = new Date(selectedDate);
			        var previousSelectedDate = GetDateFor(name);
			        var day = selectedDate.getDate();
			        var month = selectedDate.getMonth() + 1;
			        var year = selectedDate.getFullYear();
			        document.getElementById(name + 'day').value = day;
			        document.getElementById(name + 'month').value = month;
			        document.getElementById(name + 'year').value = year;

			        LoadDateFromDateParts(name);
			        if (name != "EndDateR") {
			            //console.log(name + ":date trigger1");
			            $('#' + name).trigger('change');
			            if (!inline && selectedDate.getTime() !== previousSelectedDate.getTime()) {
			                $datePicker.find('.date-picker-text').text(BuildDateFromDateParts(day, month, year));
			            }
			        }

			        var endDate = document.getElementById(endPickerName);
			        if (endDate != null && $("#" + endPickerName + 'day').is(':visible')) {
			            var startDate = document.getElementById(name);

			            if (autoUpdate) {
			                //auto update enabled code start
			                if (startDate != null && endDate != null) {
			                    var current = GetDateFor(name);
			                    var bounded = GetDateFor(endPickerName);
			                    if (bounded >= previousSelectedDate) {
			                        var days = daydiff(previousSelectedDate, current);
			                        var newBound = addDays(bounded, days);
			                        document.getElementById(endPickerName + 'day').value = newBound.getDate();;
			                        document.getElementById(endPickerName + 'month').value = parseInt(newBound.getMonth()) + 1;
			                        document.getElementById(endPickerName + 'year').value = newBound.getFullYear();
			                        var visibleEnd = BuildDateFromDateParts(document.getElementById(endPickerName + 'day').value, document.getElementById(endPickerName + 'month').value, document.getElementById(endPickerName + 'year').value);
			                        endDate.value = visibleEnd;
			                    }
			                    if (name != "EndDateR") {
			                        //console.log("end date trigger");
			                        //console.log(endPickerName + ":date trigger1");
			                        $('#' + endPickerName + 'day').trigger('change');
			                        $('#' + endPickerName + 'month').trigger('change');
			                        $('#' + endPickerName + 'year').trigger('change');
			                    }
			                }
			                //auto update enabled code end
			            }
			            else {
			                //auto update disabled code start
			                if (startDate != null && endDate != null) {
			                    if (GetDateFor(name) > GetDateFor(endPickerName)) {
			                        endDate.value = startDate.value;
			                        document.getElementById(endPickerName + 'day').value = document.getElementById(name + 'day').value; ;
			                        document.getElementById(endPickerName + 'month').value = document.getElementById(name + 'month').value;
			                        document.getElementById(endPickerName + 'year').value = document.getElementById(name + 'year').value;
			                        $('#' + endPickerName).trigger('change');
			                    }
			                }
			                //auto update disabled code end
			            }
			        }
			    }
		    );

        $datePicker.dpSetSelected(currentDate);

        $('#' + name + 'day').on('change', HandleFieldsChanged);
        $('#' + name + 'month').on('change', HandleFieldsChanged);
        $('#' + name + 'year').on('change', HandleFieldsChanged);

        function daydiff(first, second) {
          return Math.round((second - first) / (1000 * 60 * 60 * 24));
        }
        function addDays(startDate, numberOfDays) {
          var returnDate = new Date(
                                  startDate.getFullYear(),
                                  startDate.getMonth(),
                                  startDate.getDate() + numberOfDays,
                                  startDate.getHours(),
                                  startDate.getMinutes(),
                                  startDate.getSeconds());
          return returnDate;
        }

        function HandleFieldsChanged() {
            var d = GetDateFor(name);
            LoadDateFromDateParts(name);
            $('#' + name).trigger('change');
            var endDate = document.getElementById(endPickerName);
            if (endDate != null && $("#" + endPickerName + 'day').is(':visible')) {
                var startDate = document.getElementById(name);
                if (startDate != null && endDate != null) {
                    if (GetDateFor(name) > GetDateFor(endPickerName)) {
                        endDate.value = startDate.value;

                        document.getElementById(endPickerName + 'day').value = document.getElementById(name + 'day').value;
                        document.getElementById(endPickerName + 'month').value = document.getElementById(name + 'month').value;
                        document.getElementById(endPickerName + 'year').value = document.getElementById(name + 'year').value;
                        $('#' + endPickerName).trigger('change');
                    }
                }
            }
            $('#' + elementId).dpSetSelected(d.asString());
        }

        function LoadDateFromDateParts(name) {
            document.getElementById(name).value = BuildDateFromDateParts(document.getElementById(name + 'day').value, document.getElementById(name + 'month').value, document.getElementById(name + 'year').value);
            document.getElementById(name).value = ValidateDate(document.getElementById(name).value);
            var DMYArray = document.getElementById(name).value.split('-');
            document.getElementById(name + 'day').value = DMYArray[dateOrder[0]];
            document.getElementById(name + 'month').value = DMYArray[dateOrder[1]];
            document.getElementById(name + 'year').value = DMYArray[dateOrder[2]];
        }

        function BuildDateFromDateParts(day, month, year) {
            var value = '';
            for (var i = 0; i < dateOrder.length; i++) {
                if (dateOrder[0] == i) {
                    value += addLeadingZero(day);
                }
                else if (dateOrder[1] == i) {
                    value += addLeadingZero(month);
                }
                else if (dateOrder[2] == i) {
                    value += year;
                }
                if (i < 2)
                    value += '-';
            }
            return value;
        }

        function addLeadingZero(num, size) {
            if (!size) {
                size = 2;
            }
            var s = num + "";
            while (s.length < size) s = "0" + s;
            return s;
        }
        function getDateString(date) {
            return addLeadingZero(date.getDate()) + '-' + addLeadingZero((date.getMonth() + 1)) + '-' + date.getFullYear();
        }

        function daysInFebruary(year) {
            // February has 29 days in any year evenly divisible by four,
            // EXCEPT for centurial years which are not also divisible by 400.
            return (((year % 4 == 0) && ((!(year % 100 == 0)) || (year % 400 == 0))) ? 29 : 28);
        }

        function DaysArray(n) {
            for (var i = 1; i <= n; i++) {
                this[i] = 31;
                if (i == 4 || i == 6 || i == 9 || i == 11) { this[i] = 30; }
                if (i == 2) { this[i] = 29; }
            }
            return this;
        }

        function ValidateDate(dtStr) {
            var temp = ValidateDateIterative(dtStr);
            while (dtStr != temp) {
                dtStr = temp;
                temp = ValidateDateIterative(temp);
            }

            return temp;
        }

        function ValidateDateIterative(dtStr) {

            if (dtStr.length < 1)
                return '';
            var dtCh = '-';
            var dayMinus = 1;
            if (dtStr.substring(0, 1) == '-') {
                dayMinus = -1;
                dtStr = dtStr.substring(1, dtStr.length);
            }
            var daysInMonth = DaysArray(12);
            var dayArray = dtStr.split('-');
            var strDay = trimNumber(dayArray[dateOrder[0]]);
            var strMonth = trimNumber(dayArray[dateOrder[1]]);
            var strYear = trimNumber(dayArray[dateOrder[2]]);

            month = parseInt(strMonth);
            day = parseInt(strDay) * dayMinus;
            year = parseInt(strYear);

            //fix day
            if (strDay.length < 1 || day < 1) {
                month = month - 1;
                if (month == 0) {
                    month = 12;
                    year = year - 1;
                }
                if (month == 2)
                    day = daysInFebruary(year) + (day);
                else
                    day = daysInMonth[month] + (day);
            }
            else if (strDay.length < 1 || day > 31 || (month == 2 && day > daysInFebruary(year)) || day > daysInMonth[month]) {
                if (month == 2)
                    day = (day - daysInFebruary(year));
                else
                    day = day - daysInMonth[month];
                month = month + 1;
            }
            //fix month
            if (strMonth.length < 1 || month < 1) {
                month = 12 + (month) - 1;
                year = year - 1;
            }
            else if (strMonth.length < 1 || month > 12) {
                month = (month - 12);
                year = year + 1;
            }

            //fix year
            year > 9999 ? year = 9999 : year = year;

            return BuildDateFromDateParts(day, month, year);
        }

        function trimNumber(s) {
            while (s.substr(0, 1) == '0' && s.length > 1) {
                s = s.substr(1, 9999);
            }
            return s;
        }
    });
}

function IncrementDateBy(id, value) {
    var currentDate = GetDateFor(id);
    if (currentDate === null) {
        return;
    }
    var nextDate = new Date(currentDate.getFullYear(), currentDate.getMonth(), currentDate.getDate() + value);
    var upperBound = new Date(9999, 11, 31);
    if (nextDate > upperBound) {
        nextDate = upperBound;
    }
    $('#' + id + 'day').val(nextDate.getDate());
    $('#' + id + 'month').val(nextDate.getMonth() + 1);
    $('#' + id + 'year').val(nextDate.getFullYear());
}