﻿
var TreeMenu = function (options) {
    var attachSortables = function () {
        $(".sortable", '#' + options.MenuId).sortable({ axis: 'y', cursor: 'move', items: '.draggable', handle: 'img',
            update: function (event, ui) {
                var movedId = ui.item.attr('id') || -1;
                var predecessorId = ui.item.prev().attr('id') || -1;
                $.post($(event.target).closest('ul').attr('sorturl'), { movedId: movedId, predecessorId: predecessorId }, $.noop());
            }
        });
    };

    function deleteAdminTreeMenuSelectionCookie() {
        $.cookie('AdminTreeMenuSelection', null, { path: '/' });
    }

    function turnMenuIntoDropDown(administrationObject, clickFirstItem) {
        if ($('#AdministrationTreeMenu .header').length > 1) {

            $("<select style='width: 197px; margin-left: 2px;background:rgb(25, 25, 25);color:white;' />").prependTo('#AdministrationTreeMenu #treemenu_' + administrationObject);

            var arr = $('#AdministrationTreeMenu li.header');

            $.each(arr, function (i, val) {
                var option = $(val).clone()    //clone the element
                       .children() //select all the children
                       .remove()   //remove all the children
                       .end()  //again go back to selected element
                       .text().trim();

                $('<option />', {
                    'value': option,
                    'text': option
                }).appendTo('#AdministrationTreeMenu #treemenu_' + administrationObject + ' select');

            });

            $('#AdministrationTreeMenu .header').css("display", "none");
            if ($.cookie("AdminTreeMenuSelection")) {
                var treeItem = $.cookie("AdminTreeMenuSelection");
                if (treeItem) {
                    var activeResource = null;
                    $('#AdministrationTreeMenu .header').each(function () {
                        var text = $(this).html();
                        var ulIndex = $(this).html().indexOf('<ul>');
                        if (ulIndex > -1) {
                            text = text.substring(0, ulIndex);
                        }
                        text = text.replace(/&nbsp;/g, "").trim();

                        if (text == treeItem) {
                            activeResource = $(this);
                        }
                    });

                    if (activeResource == null) {
                        activeResource = $('#AdministrationTreeMenu .header:contains(' + treeItem + ')');
                    }

                    activeResource = activeResource.contents().filter(function () {
                        if (this.nodeValue) {
                            return $.trim(this.nodeValue) === treeItem;
                        }
                        return false;
                    }).parent();

                    if (activeResource != null && activeResource.length > 0) {
                        activeResource.css("display", "list-item");
                    }
                    else {
                        deleteAdminTreeMenuSelectionCookie();
                        $('#AdministrationTreeMenu .header:first').css("display", "list-item");
                    }
                    if (clickFirstItem && $('#treemenu_' + administrationObject + ' li:visible .selected').length == 0) {
                        $('ul:first li:first ul li:first a', activeResource).click();

                    }
                    $('#AdministrationTreeMenu #treemenu_' + administrationObject + ' select option[value="' + treeItem + '"]').attr("selected", "selected");
                }
            } else {
                $('#AdministrationTreeMenu .header:first').css("display", "list-item");
                if ($('#treemenu_' + administrationObject + ' li:visible .draggable.selected').length == 0) {
                    $('.treeMenu a').first().click();
                }
            }

            $('#AdministrationTreeMenu #treemenu_' + administrationObject + ' select').change(function () {
                var selectOption = $('#AdministrationTreeMenu #treemenu_' + administrationObject + ' select option:selected').text();
                   
                var activeResource = null;

                $('#AdministrationTreeMenu .header').each(function () {
                    var text = $(this).html();
                    var ulIndex = $(this).html().indexOf('<ul>');
                    if (ulIndex > -1) {
                        text = text.substring(0, ulIndex);
                    }
                    text = text.replace(/&nbsp;/g, "").trim();

                    if (text == selectOption) {
                        activeResource = $(this);
                    }
                });

                if (activeResource == null) {
                    activeResource = $('#AdministrationTreeMenu .header:contains(' + selectOption + ')');
                }

                activeResource = activeResource.contents().filter(function () {
                    if (this.nodeValue) {
                        return $.trim(this.nodeValue) === selectOption;
                    }
                    return false;
                }).parent();

                $('#AdministrationTreeMenu .header').css("display", "none");
                activeResource.css("display", "list-item");
                $('ul:first li:first ul li:first a', activeResource).click();

                $.cookie('AdminTreeMenuSelection', selectOption, { path: '/' });
                var x = $('#AdministrationTreeMenu .header').filter(function () {
                    return this.style.display == 'list-item';
                });

                $(x).css({ 'background-color': 'white', 'padding-top': '0', 'line-height': '0', 'font-size': '0' });
            });

            var x = $('#AdministrationTreeMenu .header').filter(function () {
                return this.style.display == 'list-item';
            });

            $(x).css({ 'background-color': 'white', 'padding-top': '0', 'line-height': '0', 'font-size': '0' });

        } else {
          $('#AdministrationTreeMenu .header:first').css("display", "list-item");
          if ($('#treemenu_' + administrationObject + ' li:visible .draggable.selected').length == 0) {
            $('.treeMenu a').first().click();
          }
        }

    }


    $(function () {
        attachSortables();
    });

    return {
        update: function (treeMenuLocation, enableDropDown, administrationObject, clickFirstItem) {
            $.post(options.UpdateUrl, { TreeLocation: treeMenuLocation },
                function (data, textStatus) {
                    $('#' + options.MenuId).html(data);
                    attachSortables();
                    if (enableDropDown) {
                        turnMenuIntoDropDown(administrationObject, clickFirstItem);
                    }
                }
            );
        },
        markAsSelected: function (elem) {
            $('li', '#' + options.MenuId).removeClass('selected');
            $(elem).parent('li').addClass('selected');
        },
        createDropDownMenu: function (administrationObject) {
            turnMenuIntoDropDown(administrationObject, true);
        }
    };
};