﻿function TimeUtility(options) {
      return this;
}

$.extend(TimeUtility.prototype, {
    createTime: function(time) {
        return new Date(time.Year, time.Month-1,time.Day,time.Hour, time.Minute, time.Second, time.Millisecond);
    }
});

$.extend(TimeUtility.prototype, {
    sortArray: function (dateArray) {
        
    }
});  

$.extend(TimeUtility.prototype, {
    addToTime: function(dateObject, minutes) {
        return new Date(dateObject.getTime() + (minutes * 60000));
    }
});

$.extend(TimeUtility.prototype, {
    getLanguage: function (languageCode) {
        if (languageCode == 'da-DK') {
            return {
                Sun: "Sø",
                Mon: "Ma",
                Tue: "Ti",
                Wed: "On",
                Thu: "To",
                Fri: "Fr",
                Sat: "Lø",
                Sunday: "Søndag",
                Monday: "Mandag",
                Tuesday: "Tirsdag",
                Wednesday: "Onsdag",
                Thursday: "Torsdag",
                Friday: "Fredag",
                Saturday: "Lørdag",
                Jan: "Jan",
                Feb: "Feb",
                Mar: "Mar",
                Apr: "Apr",
                May: "Maj",
                Jun: "Jun",
                Jul: "Jul",
                Aug: "Aug",
                Sep: "Sep",
                Oct: "Okt",
                Nov: "Nov",
                Dec: "Dec",
                January: "Januar",
                February: "Februar",
                March: "Marts",
                April: "April",
                June: "Juni",
                July: "Juli",
                August: "August",
                September: "September",
                October: "Oktober",
                November: "November",
                December: "December"
            };
        }
        if (languageCode == 'nb-NO') {
            return {
                Sun: "Sø",
                Mon: "Ma",
                Tue: "Ti",
                Wed: "On",
                Thu: "To",
                Fri: "Fr",
                Sat: "Lø",
                Sunday: "Søndag",
                Monday: "Mandag",
                Tuesday: "Tirsdag",
                Wednesday: "Onsdag",
                Thursday: "Torsdag",
                Friday: "Fredag",
                Saturday: "Lørdag",
                Jan: "Jan",
                Feb: "Feb",
                Mar: "Mar",
                Apr: "Apr",
                May: "Mai",
                Jun: "Jun",
                Jul: "Jul",
                Aug: "Aug",
                Sep: "Sep",
                Oct: "Okt",
                Nov: "Nov",
                Dec: "Des",
                January: "Januar",
                February: "Februar",
                March: "Mars",
                April: "April",
                June: "Juni",
                July: "Juli",
                August: "August",
                September: "September",
                October: "Oktober",
                November: "November",
                December: "Desember"
            };
        }

        return null;
    }
});

$.extend(TimeUtility.prototype, {
    formatTime: function (sFormat, dateObject, language) {
        // %a
        daysAbbrvNames = new Array(7);
        daysAbbrvNames[0] = "Sun";
        daysAbbrvNames[1] = "Mon";
        daysAbbrvNames[2] = "Tue";
        daysAbbrvNames[3] = "Wed";
        daysAbbrvNames[4] = "Thu";
        daysAbbrvNames[5] = "Fri";
        daysAbbrvNames[6] = "Sat";

        // %A
        daysFullNames = new Array(7);
        daysFullNames[0] = "Sunday";
        daysFullNames[1] = "Monday";
        daysFullNames[2] = "Tuesday";
        daysFullNames[3] = "Wednesday";
        daysFullNames[4] = "Thursday";
        daysFullNames[5] = "Friday";
        daysFullNames[6] = "Saturday";

        // %b
        monthsAbbrvNames = new Array(12);
        monthsAbbrvNames[0] = "Jan";
        monthsAbbrvNames[1] = "Feb";
        monthsAbbrvNames[2] = "Mar";
        monthsAbbrvNames[3] = "Apr";
        monthsAbbrvNames[4] = "May";
        monthsAbbrvNames[5] = "Jun";
        monthsAbbrvNames[6] = "Jul";
        monthsAbbrvNames[7] = "Aug";
        monthsAbbrvNames[8] = "Sep";
        monthsAbbrvNames[9] = "Oct";
        monthsAbbrvNames[10] = "Nov";
        monthsAbbrvNames[11] = "Dec";

        // %B
        monthsFullNames = new Array(12);
        monthsFullNames[0] = "January";
        monthsFullNames[1] = "February";
        monthsFullNames[2] = "March";
        monthsFullNames[3] = "April";
        monthsFullNames[4] = "May";
        monthsFullNames[5] = "June";
        monthsFullNames[6] = "July";
        monthsFullNames[7] = "August";
        monthsFullNames[8] = "September";
        monthsFullNames[9] = "October";
        monthsFullNames[10] = "November";
        monthsFullNames[11] = "December";

        var languageArr = this.getLanguage(language);
        if(languageArr) {
            
            daysAbbrvNames[0] = languageArr.Sun;
            daysAbbrvNames[1] = languageArr.Mon;
            daysAbbrvNames[2] = languageArr.Tue;
            daysAbbrvNames[3] = languageArr.Wed;
            daysAbbrvNames[4] = languageArr.Thu;
            daysAbbrvNames[5] = languageArr.Fri;
            daysAbbrvNames[6] = languageArr.Sat;

            // %A
            daysFullNames[0] = languageArr.Sunday;
            daysFullNames[1] = languageArr.Monday;
            daysFullNames[2] = languageArr.Tuesday;
            daysFullNames[3] = languageArr.Wednesday;
            daysFullNames[4] = languageArr.Thursday;
            daysFullNames[5] = languageArr.Friday;
            daysFullNames[6] = languageArr.Saturday;

            // %b
            monthsAbbrvNames[0] = languageArr.Jan;
            monthsAbbrvNames[1] = languageArr.Feb;
            monthsAbbrvNames[2] = languageArr.Mar;
            monthsAbbrvNames[3] = languageArr.Apr;
            monthsAbbrvNames[4] = languageArr.May;
            monthsAbbrvNames[5] = languageArr.Jun;
            monthsAbbrvNames[6] = languageArr.Jul;
            monthsAbbrvNames[7] = languageArr.Aug;
            monthsAbbrvNames[8] = languageArr.Sep;
            monthsAbbrvNames[9] = languageArr.Oct;
            monthsAbbrvNames[10] = languageArr.Nov;
            monthsAbbrvNames[11] = languageArr.Dec;

            // %B
            monthsFullNames[0] = languageArr.January;
            monthsFullNames[1] = languageArr.February;
            monthsFullNames[2] = languageArr.March;
            monthsFullNames[3] = languageArr.April;
            monthsFullNames[4] = languageArr.May;
            monthsFullNames[5] = languageArr.June;
            monthsFullNames[6] = languageArr.July;
            monthsFullNames[7] = languageArr.August;
            monthsFullNames[8] = languageArr.September;
            monthsFullNames[9] = languageArr.October;
            monthsFullNames[10] = languageArr.November;
            monthsFullNames[11] = languageArr.December;
        }

        var timeNow = "";
        var i = 0;
        var index = 0;
        while ((index = sFormat.indexOf("%", i)) != -1) {
            timeNow += sFormat.substring(i, index);
            index++;

            var property = getProperty(dateObject, sFormat.charAt(index));
            index++;

            timeNow += property;
            i = index;
        }

        timeNow += sFormat.substring(i);
        return timeNow;

        function getProperty(dateObject, property) {

            switch (property) {
                case "a": // abbrv day names
                    return (daysAbbrvNames[dateObject.getDay()]);
                case "A": // full day names
                    return (daysFullNames[dateObject.getDay()]);
                case "b": // abbrv month names
                    return (monthsAbbrvNames[dateObject.getMonth()]);
                case "B": // full month names
                    return (monthsFullNames[dateObject.getMonth()]);
                case "d": // day 01-31
                    return ((dateObject.getDate() < 10) ? "0" : "") + dateObject.getDate();
                case "H": // hour as a decimal number using a 24-hour clock (range 00 to 23)
                    return ((dateObject.getHours() < 10) ? "0" : "") + dateObject.getHours();
                case "I": // hour as a decimal number using a 12-hour clock (range 01 to 12)
                    var hours = (dateObject.getHours() % 12 || 12);
                    return ((hours < 10) ? "0" : "") + hours;
                case "i": // hour as a decimal number using a 12-hour clock (range 01 to 12)
                    var hours = (dateObject.getHours() % 12 || 12);
                    return hours;
                case "m": // month number
                    return ((dateObject.getMonth() < 9) ? "0" : "") + (dateObject.getMonth() + 1);
                case "M": // minute as a decimal number
                    return ((dateObject.getMinutes() < 10) ? "0" : "") + dateObject.getMinutes();
                case "p": // either `am' or `pm' according to the given time value,
                    // or the corresponding strings for the current locale
                    return (dateObject.getHours() < 12 ? "am" : "pm");
                case "P": // either `AM' or `PM' according to the given time value,
                    return (dateObject.getHours() < 12 ? "AM" : "PM");
                case "S": // second as a decimal number
                    return ((dateObject.getSeconds() < 10) ? "0" : "") + dateObject.getSeconds();
                case "y": // two-digit year
                    return dateObject.getFullYear().toString().substring(2);
                case "Y": // full year
                    return (dateObject.getFullYear());
                case "%":
                    return "%";
            }
        }
    }


});

$.extend(TimeUtility.prototype, {
      convertFromDotNet: function(sFormat) {
            var sWhat = sFormat;
            var previous;
            sWhat = replaceFormat(sWhat, "yyyy", "%Y");
            sWhat = replaceFormat(sWhat, "yy", "%y");
            previous = sWhat;
            sWhat = replaceFormat(sWhat, "MMMM", "%b");
            if (previous === sWhat) {
                sWhat = replaceFormat(sWhat, "MM", "%m");
            }
            if (previous === sWhat) {
                sWhat = replaceFormat(sWhat, "M", "%m");
            }
            previous = sWhat;
            sWhat = replaceFormat(sWhat, "dddd", "%a");

            previous = sWhat;
            sWhat = replaceFormat(sWhat, "ddd", "%a");
            
            previous = sWhat;
            sWhat = replaceFormat(sWhat, "dd", "%d");

            if (previous === sWhat) {
                sWhat = replaceFormat(sWhat, "d", "%d");
            }
            sWhat = replaceFormat(sWhat, "HH", "%H");

            if (previous === sWhat) {
                sWhat = replaceFormat(sWhat, "H", "%H");
            }
            sWhat = replaceFormat(sWhat, "hh", "%I");
            
            sWhat = replaceFormat(sWhat, "h", "%i");
            
            sWhat = replaceFormat(sWhat, "mm", "%M");
            sWhat = replaceFormat(sWhat, "ss", "%S");
            sWhat = replaceFormat(sWhat, "tt", "%p");
            
            return sWhat;

            function replaceFormat(sFormat, par1, par2) {
                return sFormat.replace(par1, par2);
            }
        }
});

$.timeUtility = TimeUtility;


/*
function MyClass(options) {
      return this;
}
$.extend(MyClass.prototype, {
      MyClassMethod: function(options) {
            // do something
      }
});

$.myPlugin = MyClass;


*/