﻿(function ($) {

    $.fn.tooltip = function (options) {
        var settings = $.extend(
        {
            delay: 200,
            fade: false,
            showURL: true,
            extraClass: "",
            top: 15,
            left: 15,
            id: "tooltip",
            text: null,
            updateText: null
        }
        , options);
        /*each*/
        function setTextFromTitle(title) {
            if (title !== undefined && title !== '') {
                var newtitle = ReplaceNewLine(title);
                settings.text = newtitle;
            }
        }

        this.each(function () {
            settings.text = null;
            if (settings.updateText) {
                settings.text = settings.updateText;
            }
            if (!settings.text) {//use text
                setTextFromTitle($(this).prop('title'));
            }

            if (settings.text) {

                if ($(this).attr('data-qtip-created') == 'true') {
                    $(this).qtip("api").set('content.text', settings.text);
                }
                else {
                    position = getPosition($(this));
                    $(this).attr('data-qtip-created', 'true');
                    var qTipOptions = {
                        content: { text: settings.text },
                        style: {
                            classes: 'ui-tooltip-pn-default'
                        },
                        position: getPosition($(this))
                        
                    };

                    $(this).qtip(qTipOptions);
                }
            }
            else {
                if ($(this).attr('data-qtip-created') == 'true') {
                    $(this).removeAttr('data-qtip-created');
                    $(this).qtip('api').destroy();
                }
            }
        });
        
        function getPosition(el) {
            var toLeft = el.offset().left > ($(window).width() / 2) || el.hasClass('Left');
            var up = (el.offset().top + 200) > $(window).height();

            if (!toLeft && !up) {

            }
            else if (toLeft && up) {
                return {
                    my: 'bottom right',
                    at: 'top left'
                };
            }
            else if (toLeft) {
                return {
                    my: 'top right',
                    at: 'bottom left'
                };
            }
            else if (up) {
                return {
                    my: 'bottom left',
                    at: 'top right'
                };
            }
            return {};
        }

        function ReplaceNewLine(title) {
            var regX = /\n/gi;

            s = new String(title);
            s = s.replace(regX, "<br /> \n");
            return s;
        }

        return this;
    }; //plugin end

} (jQuery));     