function DisplayReload(options) {
  var settings = $.extend(
    {
      source: "Unknown",
    },
    options
  );

  var delayHandle = null;

  this.doReloadIfSafe = function (reason) {
    doReload(reason, false, false);
  };

  this.doReload = function (reason) {
    doReload(reason, true, false);
  };

  this.forceReload = function (reason) {
    doReload(reason, false, true);
  };

  this.doGlobalRefresh = function (reason) {
    var getUrl = $("#ScreenContainer").attr("src");
    var postUrl = getUrl.replace("ShowContent", "Show");
    postUrl = addReason(postUrl, "refreshReason", reason);
    window.parent.location.href = postUrl;
  };

  this.reloadIfSafe = function (reason) {
    reload(reason);
  };

  this.globalReloadIfSafe = function (currentScreenContainerVersion, screenContainerVersion) {
    var getUrl = location.href;
    var self = this;
    $.ajax({
      url: getUrl,
      success: function (data) {
        if (
          currentScreenContainerVersion &&
          screenContainerVersion &&
          screenContainerVersion != currentScreenContainerVersion
        ) {
          self.doGlobalRefresh(currentScreenContainerVersion, screenContainerVersion);
        }
      },
      error: function (request, status, error) {},
    });
  };

  function reload(reason) {
    if (reason === undefined) {
      reason = "UndefinedInput";
    }
    reloadIframe(reason);
  }

  function reloadIframe(reason) {
    if (delayHandle != null) {
      return;
    }
    var random = getScheduledReloadTime();
    delayHandle = setTimeout(function () {
      delayHandle = null;
      $("#ScreenContainer").attr("src", getContainerRefresh(reason));
    }, random);
  }

  function getContainerRefresh(reason) {
    var postUrl = $("#ScreenContainer").attr("src");
    postUrl = addReason(postUrl, "refreshReason", reason);
    return postUrl;
  }

  function doReload(reason, confirmOnFail, forceReload) {
    console.log("doReload called");
    if (delayHandle != null) {
      console.log("reload was requested but already scheduled");
      return;
    }
    var random = getScheduledReloadTime();
    console.log("reload will happen in:" + random / 1000 + "sec");
    delayHandle = setTimeout(function () {
      delayHandle = null;
      var getUrl = window.location.href;
      getUrl = getUrl.replace("ShowContent", "GetDisplayData");
      var postUrl = getUrl.replace("GetDisplayData", "Show");

      postUrl = addReason(postUrl, "refreshReason", reason);
      console.log(postUrl);

      if (forceReload) {
        window.parent.location.href = postUrl;
      }
      $.get(getUrl, function () {
        window.parent.location.href = postUrl;
      })
        .done(function () {})
        .fail(function (xhr, ajaxOptions, thrownError) {
          if (confirmOnFail) {
            var status = xhr.status;
            if (confirm("Are you sure you want to reload, the server respond was: " + status + ", " + thrownError)) {
              window.parent.location.href = postUrl;
            }
          }
        });
    }, random);
  }

  function getScheduledReloadTime() {
    return getRandomInt(60, 120) * 1000;
  }

  function getRandomInt(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
  }

  function getAppendSymbol(t) {
    if (t.indexOf("?") > -1) {
      return "&";
    } else {
      return "?";
    }
  }
  function addReason(t, updateparam, withvalue) {
    var postUrl = addReasonInstance(t, updateparam, withvalue);
    return postUrl; //addReasonInstance(postUrl, "refreshTimestamp", new Date().getTime());
  }

  function addReasonInstance(t, updateparam, withvalue) {
    if (withvalue === undefined) {
      withvalue = "WithvalueUndefined";
    }
    //console.log("IMPORTANT:" + withvalue);
    withvalue = settings.source + withvalue;
    var idx = t.indexOf(updateparam);
    if (idx == -1) {
      t = t + getAppendSymbol(t) + updateparam + "=" + withvalue;
    } else {
      var orginal = t;
      t = t.substring(idx, t.length);
      orginal = orginal.replace(t, "");
      var params = t.split("&");
      if (params.length > 0) {
        var reloadParts = params[0].split("=");
        var intPart = 1;
        if (reloadParts.length > 0) {
          intPart = withvalue;
        }
        t = t.replace(params[0], "") + "&" + updateparam + "=" + intPart;
      }
      t = orginal.substring(0, idx) + t;
      t = t.replace("&&", "&");
      t = t.replace("?&", "?");
    }
    //console.log(t);
    if (t.length > 2000) {
      t = t.substring(0, 2000);
    }
    return t;
  }

  return this;
}
