﻿function ScreenDuration() {
  var timeUtility = new TimeUtility();

  /**
   * @returns {number}
   */
  this.getDuration = function (currentTime, currentDuration, addDuration, maxDuration, initialize, roundUp) {
    var duration = currentDuration + addDuration;
    roundUp = true;
    initialize = false;
    if (initialize) {
      duration = roundUp ? roundDurationUp(currentTime, addDuration) : addDuration;
    } else {
      duration = roundDurationDownByMinute(currentTime, duration);
    }
    var count = 0;
    while (duration > maxDuration && count < 100) {
      count++;
      duration -= 15;
    }

    return duration;
  };

  this.getCurrentDuration = function (element) {
    var data = element.data("primaryDuration");
    var duration = 0;

    if (data) {
      duration = parseInt(data, 10);
    }
    return duration;
  };

  this.storeDuration = function (element, value) {
    element.data("primaryDuration", value);
  };

  this.getHourAndMinutes = function (value) {
    var hourAndMinutes = new Array(2);
    hourAndMinutes[0] = 0;
    if (value > 59) {
      hourAndMinutes[0] = Math.floor(value / 60);
      hourAndMinutes[1] = value - hourAndMinutes[0] * 60;
    } else {
      hourAndMinutes[1] = value;
    }
    return hourAndMinutes;
  };

  this.getDurationFromElement = function (element) {
    var value = 0;
    var el = $(element);
    if (el.attr("data-value")) {
      value = parseInt(el.attr("data-value"), 10);
    }
    return value;
  };

  function roundDurationDownByMinute(currentTime, value) {
    var dateValue = timeUtility.addToTime(currentTime, value);
    var minutes = dateValue.getMinutes();

    if (minutes != 0 && minutes != 15 && minutes != 30 && minutes != 45) {
      return value - 1;
    } else {
      return value;
    }
  }

  this.roundUp = function (currentTime, value) {
    return roundDurationUp(currentTime, value);
  };

  function roundDurationUp(currentTime, value) {
    var dateValue = timeUtility.addToTime(currentTime, value);
    var minutes = dateValue.getMinutes();
    if (minutes === 0) {
      value = value;
    } else if (minutes < 15) {
      value = value + (15 - minutes);
    } else if (minutes < 30) {
      value = value + (30 - minutes);
    } else if (minutes < 45) {
      value = value + (45 - minutes);
    } else {
      value = value + (60 - minutes);
    }
    return value;
  }

  this.roundUpToNearesQuarter = function (date) {
    var minutes = date.getMinutes();
    var hours = date.getHours();
    var m = ((((minutes + 7.5) / 15) | 0) * 15) % 60;
    var h = (((minutes / 105 + 0.5) | 0) + hours) % 24;
    date.setHours(h);
    date.setMinutes(m);
    return date;
  };

  return this;
}
