﻿function ScreenSetup(options) {
  var screenHelper = new ScreenHelper();
  var screenSettings = new ScreenSettings();

  showLoading();

  setTimeout(function () {
    setup();
  }, 10);

  function showLoading() {
    var loadingDiv = $(
      '<div style="position:absolute;top:50px;left:50px;background-color:#BBD631;color:#000;padding:3px;width:300px;border-radius: 5px;" id="pronestorSetupLoading">Loading Pronestor Display screen...</div>'
    );
    $("body").append(loadingDiv);
    loadingDiv.delay(10).animate({ width: 1000 }, 4000).hide(0);
  }

  function hideLoading() {
    var loadingDiv = $("#pronestorSetupLoading");
    loadingDiv.remove();
  }
  function setup() {
    new ScreenApiModules();
    screenHelper.logThis("setup");
    var primaryEl;
    if (options && options.elements && options.elements.primary) {
      primaryEl = screenHelper.getElements(options.elements.primary);
    } else {
      primaryEl = screenHelper.getElements("#primary");
    }

    screenSettings.storeSettings(primaryEl, options);
    new ScreenFeeder();

    screenHelper.logThis("setup done");
    hideLoading();
  }
}
