﻿function ScreenApiDialog() {
  var canOpen = true;
  var dialogArray = [];
  this.done = function () {
    console.log("dialogArray");
    console.log(dialogArray);
    if (dialogArray.length < 2) {
      $.colorbox.close();
    }
  };
  this.open = function (opt) {
    var options = $.extend({}, opt);

    if (!options.hasOwnProperty("handlebars")) {
      options.handlebars = isHandlebarsTemplate(options);
    }
    console.log("dialog opt");
    console.log(options);
    var html = getHtml(options);

    $(document)
      .unbind("cbox_complete")
      .bind("cbox_complete", function () {
        if (options.actions) {
          $(document).off("click", options.actions[0].selector);
          $(document).on("click", options.actions[0].selector, function (evt) {
            if (options.keepOpenInAction) {
              canOpen = true;
              console.log("canOpen by keepopen");
              dialogArray.pop();
            } else {
              console.log("dialogArray");
              console.log(dialogArray);
              if (dialogArray.length < 2) {
                $.colorbox.close();
              }
            }
            evt.preventDefault();
            options.actions[0].action();
          });
        }
        if (options.onLoaded) {
          options.onLoaded();
        }
        $.colorbox.resize();
        setTimeout(function () {
          $(document).on("click", "#cboxOverlay", function () {
            $.colorbox.close();
          });
        }, 1000);
      });
    $(document)
      .unbind("cbox_cleanup")
      .bind("cbox_cleanup", function () {
        $(document).off("click", "#cboxOverlay");
        if (options.onClosed) {
          options.onClosed();
        }
      });
    $(document)
      .unbind("cbox_closed")
      .bind("cbox_closed", function () {
        canOpen = true;
        console.log("canOpen");
        dialogArray.pop();
      });
    openInternal(html);
  };

  function isHandlebarsTemplate(options) {
    return $(options.template).prop("type") == "text/x-handlebars-template";
  }

  function openInternal(html) {
    if (!canOpen) {
      console.log("cant open");
      setTimeout(function () {
        openInternal(html);
      }, 100);
    } else {
      console.log("adding dialog");
      dialogArray.push(1);
      console.log("could open");
      canOpen = false;
      $.colorbox({ html: html, closeButton: false, transition: "fade", overlayClose: false });
      $.colorbox.resize();
      /*this is a hack, somewhere the opacity is set on the element, cant find it*/
      $("#cboxOverlay").css({ opacity: "0.5", filter: "alpha(opacity = 50" });

      //for old dialog
      setTimeout(function () {
        console.log($(".closeBtn").length);
        $(".closeBtn")
          .off("click")
          .on("click", function () {
            $.colorbox.close();
          });
      }, 500);
    }
  }

  function getHtml(options) {
    var html;
    if (options.handlebars) {
      options.data.Localization = ScreenModule.settings.settings().localization;
      var compiledTemplate = Handlebars.compile($(options.template).html());
      html = compiledTemplate(options.data);
    } else {
      html = $.tmpl($(options.template), options.data, ScreenModule.settings.settings().localization);
    }
    return html;
  }
}
