function ScreenGet() {
  var requestCounter = 0;
  var sleeper = new ScreenSleep();
  this.get = function (url, sendData) {
    addTimestamp();
    var dfd = $.Deferred();

    if (sleeper.isSleeping()) {
      dfd.resolve(ScreenModule.data.getScreenData());
      return dfd.promise();
    }
    requestCounter++;
    ScreenModule.helper.logThis3("Poll start:" + sendData.TimeStamp);
    if (requestCounter > 1) {
      ScreenModule.helper.logThis3("request lost");
      dfd.reject("request lost");
    }
    if (ScreenModule.settings.settings().useEventModels) {
      url = url.replace("eventModels=false", "eventModels=true").replace("eventModels=False", "eventModels=True");
    }
    $.ajax(url, {
      data: sendData,
      timeout: 5 * 60 * 1000,
      success: function (data) {
        sleeper.removeSleeper();
        data = ScreenModule.eventModel.convertEventDates(data);
        var endStamp = ScreenModule.helper.getTimeStamp();
        var newnum = parseInt(endStamp) - parseInt(sendData.TimeStamp, 10);
        ScreenModule.helper.logThis3("Poll success[" + newnum + "sek]:" + sendData.TimeStamp);
        requestCounter--;
        dfd.resolve(data);
      },
      error: function (jqXhr, textStatus, errorThrown) {
        sleeper.removeSleeper();
        var endStamp = ScreenModule.helper.getTimeStamp();
        var newnum = parseInt(endStamp) - parseInt(sendData.TimeStamp, 10);
        ScreenModule.helper.logError("Poll error[" + newnum + "sek]:" + jqXhr + "|" + textStatus + "|" + errorThrown);
        requestCounter--;
        if (textStatus == "timeout") {
          console.log("timeout reject");
          dfd.reject("request timeout");
        } else {
          dfd.reject(jqXhr, textStatus, errorThrown);
        }
      },
    });
    return dfd.promise();
  };

  function addTimestamp() {
    try {
      var timeStamp = ScreenModule.helper.getTimeStamp().toString();
      if (window.android) {
        window.android.getTimestamp(timeStamp);
      }

      getTimestampElement().val(timeStamp);
    } catch (ex) {}
  }

  function getTimestampElement() {
    var preservedId = "pronestor-timestamp-preserved-element";
    var preservedElement = $("#" + preservedId);

    if (!preservedElement || preservedElement.length == 0) {
      preservedElement = $('<input type="hidden" id="' + preservedId + '" style="width:100%;" />');
      $("body").append(preservedElement);
    }

    return preservedElement;
  }

  this.getDemo = function (demoHandler) {
    var dfd = $.Deferred();
    var demodata = getDemo(demoHandler);
    if (demodata.error) {
      dfd.reject(null, demodata.error.Message, null);
    } else {
      dfd.resolve(demodata.data);
    }
    return dfd.promise();
  };

  function getDemo(demoHandler) {
    if (demoHandler) {
      var demodata = demoHandler.getDemo();
      return demodata;
    }
  }
}
